// Easy New Notebook
// Jeffrey J Weimer
// SVN History: $Revision: 855 $ on $Date: 2008-07-21 11:12:50 -0500 (Mon, 21 Jul 2008) $

#pragma rtGlobals=1

#pragma IgorVersion=6.03
#pragma version = 0.50
#pragma ModuleName=ENN

// Procedure String Constants
// define the default file folder and its name

Static StrConstant kProcFileFolder="EasyNewNotebook"
Static StrConstant kProcFileName="EasyNewNotebook.ipf"

Constant kENNHeight = 90
Constant kENNWidth = 265

// TEST MODE (comment out for actual use)
//#define TESTME

// Set Menu Hook

Function IgorMenuHook(isSel, menuStr, itemStr, itemNo, topWindowName, wt)
	Variable isSel, itemNo, wt
	String menuStr, itemStr, topWindowName

	Variable handled= 0
	switch(isSel)
		case 0:
			break
		case 1:
			if ( (cmpstr(menuStr,"New") == 0) && (cmpstr(itemStr,"Notebook") == 0) )
				Execute/P/Q "ENN#CreateNewNotebook(0)"
				handled= 1
			endif
			break
	endswitch
	return handled
End

// Create New Notebook
// initialize the package as needed and put up the panel

Static Function CreateNewNotebook(how)
	variable how

	if (DataFolderExists("root:Packages:ENN")==0)
		string cdf=GetDataFolder(1)
		SetDataFolder root:
		NewDataFolder/O/S Packages
		NewDataFolder/O/S ENN
		string/G title=""
		variable/G left, right, top, bottom
#if(exists("ScreenSizer#Initialize")==6)
		left = 5
		top = 5
		right=30
		bottom = 80
#else
		left = 0
		top = 0
		right = 200
		bottom = 300
#endif
		SetDataFolder $cdf
		ToggleMeInvisible(1)
	endif
	ShowPanel(how)
	return 0
end

// Show Panel
// put up the panel
// 0: new panel
// >0: just draw the buttons with top offset = how!!!!!
// -1: remove buttons added above!!!
// -2: redisplay buttons removed above!!!

Static Function ShowPanel(how)
	variable how

	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom
	
	// create the panel

	switch(how)
	
		// show certain panel controls
		
		case -2:
			SetVariable enn_left, disable=0
			SetVariable enn_top, disable=0
			SetVariable enn_bottom, disable=0
			SetVariable enn_right, disable=0
			PopupMenu enn_killstate, disable=0
			CheckBox enn_format, disable=0
			ControlInfo enn_format
			CheckBox enn_ruler, disable=!(V_value)
			PopupMenu enn_name, disable=0
			ControlInfo enn_WD
			if (V_flag!=0)
				PopupMenu enn_WD, disable=0
			endif
			title = ""
			break
	
		// remove certain panel controls
		
		case -1:
			SetVariable enn_left, disable=1
			SetVariable enn_top, disable=1
			SetVariable enn_bottom, disable=1
			SetVariable enn_right, disable=1
			PopupMenu enn_killstate, disable=1
			CheckBox enn_format, disable=1
			CheckBox enn_ruler, disable=1
			PopupMenu enn_name, disable=1
			ControlInfo enn_WD
			if (V_flag!=0)
				PopupMenu enn_WD, disable=1
			endif
			break
			
		// create the panel
		
		case 0:
			title = ""
			string pname = "ENN Panel"

// use ScreenSizer if it exists
// make sure sizes are within bounds

#if(exists("ScreenSizer#Initialize")==6)
			ScreenSizer#Initialize(0)
			left = left*(left<100)
			top = top*(top<100)
			right = right*(right<100)
			right += 30*(right==0)
			bottom = bottom*(bottom<100)
			bottom += 50*(bottom==0)
			pname += " +SS"
			ScreenSizer#MakePanel(30,10,kENNWidth,kENNHeight,pname,other="/K=1/N=ENN_Panel")
#else
			NewPanel/K=1/N=ENN_Panel/W=(20,20,20+kENNWidth,20+kENNHeight) as pname
#endif

// in test mode, allow panel edits and do not use panel hook

#ifndef TESTME
			ModifyPanel noEdit=1,fixedSize=1
			SetWindow ENN_Panel hook=ENN#closeme
#else
			pname += " TEST"
#endif

// use WindowDesktops if it exists

#if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
			pname += " +WD"
#endif

			// name the panel
	
			DoWindow/T ENN_Panel,pname

			// do it

			Button enn_doit,pos={212,66},size={50,20},proc=ENN#DoIt,title="Do It"

			// NOTEBOOK CONTROLS
			
			// title and name
			
			SetVariable enn_title,pos={7,7+how},size={250,16},title="Title"
			SetVariable enn_title,value=title

		// put certain panel controls
		
		default:

// use WindowDesktops if it exists
#if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
			PopupMenu enn_WD title="",value="-;D;1;2;3;4;", pos={165,65+how},mode=2
#endif

			PopupMenu enn_name,pos={7,25+how},size={116,21},title="Name"
			PopupMenu enn_name,mode=1,popvalue="From Title",value= #"\"From Title;Time Stamp;\""
		
			// format or not
			
			CheckBox enn_format,pos={145,27+how},size={65,14},title="Format",value= 1,proc=ENN#SetFormat
			CheckBox enn_ruler,pos={210,27+how},size={43,14},title="Ruler",value= 0
		
			// kill state
			
			PopupMenu enn_killstate,pos={159,42+how},size={88,21},title="Kill"
			PopupMenu enn_killstate,mode=1,popvalue="Normal",value= #"\"Normal;Silent;NO KILL;Hide Only;\""
		
			// sizes
		
			SetVariable enn_top,pos={5,48+how},size={70,16},value=top
			SetVariable enn_left,pos={5,66+how},size={70,16},value=left
			SetVariable enn_right,pos={84,48+how},size={70,16},value=right
			SetVariable enn_bottom,pos={84,66+how},size={70,16},value=bottom

#if(exists("ScreenSizer#Initialize")==6)
			SetVariable enn_left, title="<%", limits={5,100,5}
			SetVariable enn_top, title="^%", limits={5,100,5}
			SetVariable enn_bottom, title="v%", limits={5,100,5}
			SetVariable enn_right, title=">%", limits={5,100,5}
#else
			SetVariable enn_left, title="<",limits={10,600,10}
			SetVariable enn_top, title="^",limits={10,600,10}
			SetVariable enn_right, title=">",limits={10,600,10}
			SetVariable enn_bottom, title="v",limits={10,600,10}
#endif
			break
	endswitch
	
	return 0
End

// Close Me
// close panel

Static Function CloseMe(infoStr)
	string infoStr

	SVAR title=root:Packages:ENN:title
	
	String event= StringByKey("EVENT",infoStr)
	strswitch(event)
		case "deactivate":
			if (cmpstr(title,"SetMe!")==0)
				title=""
				KillWindow ENN_Panel
				break
			endif
			beep
			DoWindow/F ENN_Panel
			title="SetMe!"
			SetVariable enn_title, activate
			beep
			break
		default:
			break
	endswitch
	return 0
end

// DoIt
// create new notebook

Static Function DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom

	variable format, kill, ruler, wd = -1
	string name=""

	switch( ba.eventCode )
		case 2:
			ControlInfo enn_format
			format = V_value
			ControlInfo enn_killstate
			kill = V_value-1
			ControlInfo enn_ruler
			ruler = V_value
			if (strlen(title)==0)
				if (strlen(ba.userData)==0)
					title="ENNotebook"
				else
					title=ba.userData
				endif
			endif
			ControlInfo enn_name
			if (V_value==1)
				name=CleanUpName(title,0)
			else
				name="ENNotebook"+CleanUpName(time(),0)
			endif
			if (strlen(WinList(name,";","WIN:16"))!=0)
				name+="X"
			endif
			ControlInfo enn_WD
			if (V_flag!=0)
				wd = V_value-2
			endif
			if (WinType("ENN_Panel"))
				KillWindow ENN_Panel
			endif
			NewNotebook/K=(kill)/F=(format)/N=$name as title
			if (format)
				Notebook $name showRuler=(ruler)
			endif
			
// use ScreenSizer if it exists

#if(exists("ScreenSizer#Initialize")==6)
			ScreenSizer#MoveFrontWindow(left, top, right, bottom)
#else
			MoveWindow left, top, right, bottom
#endif

// use Window Desktops if it exists

#if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
			if (wd>=0)
				ACL_WindowDesktops#Initialize_pnlDesktopControl()
				ACL_WindowDesktops#SetWindowDesktop(name,wd)
				ACL_WindowDesktops#ChangeDisplayedDesktop(wd,forceUpdate=1)
			endif
#endif
			break
	endswitch
	ba.userData=name
	
	return 0
End

// SetFormat
// toggle on/off the ruler CheckBox enn_depending on format checkbox

Static Function SetFormat(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			CheckBox enn_ruler, disable=!cba.checked
			break
	endswitch

	return 0
End

// Toggle Me Invisible
// 0: show procedure in folder and procedure menus
// 1: hide procedure in folder and procedure menus

Static Function ToggleMeInvisible(how)
	variable how

	string IgorProcPathStr
	PathInfo Igor
	sprintf IgorProcPathStr, "%sUser Procedures:%s:", S_path, kProcFileFolder
	NewPath/O/Q/Z TMP_ProcPath IgorProcPathStr
	GetFileFolderInfo/Q/P=TMP_ProcPath kProcFileName
	if (V_flag==0)
		if (V_isInvisible!=how)
			SetFileFolderInfo/P=TMP_ProcPath/INV=(how)/RO=(how) kProcFileName
		endif
	endif
	KillPath/Z TMP_ProcPath
	return 0
end
